//#version 120 //attribute
precision mediump float;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureWhite;
uniform sampler2D fTextureOrg;
uniform int useAutoProgress;
uniform float autoProgress;//进度 0-1;

void main() {
    if (aCoordinate.x <= 0.001 || aCoordinate.y<=0.001 || aCoordinate.x >= 0.999 || aCoordinate.y >=0.999){
        gl_FragColor = vec4(1, 1, 1, 1);
    } else {
        vec4 rgbaWhite  = texture2D(fTextureWhite, aCoordinate);
        if (rgbaWhite != vec4(0, 0, 0, 0)){
            vec4 base = texture2D(fTextureOrg, aCoordinate);
            float gray = dot(base.rgb, vec3(0.299, 0.587, 0.114));
            gl_FragColor = vec4(gray, gray, gray,0.05);
        }
    }

    if (useAutoProgress == 1){
        if (aCoordinate.y <= 0.01 && aCoordinate.x <= autoProgress*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), aCoordinate.x*0.25);
        }
        if (aCoordinate.x >= 0.99 && aCoordinate.y <= (autoProgress-0.25)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.25+aCoordinate.y*0.25);
        }
        if (aCoordinate.y >= 0.99 && aCoordinate.x >= 1.0-(autoProgress-0.5)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.5+(1.0-aCoordinate.x)*0.25);
        }
        if (aCoordinate.x <= 0.01 && aCoordinate.y >= 1.0-(autoProgress-0.75)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.75+(1.0-aCoordinate.y)*0.25);
        }
    }
}

