//#version 120 //attribute
//precision highp float;
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标
uniform sampler2D fTextureWhite;
uniform sampler2D fTextureMosaic;
uniform sampler2D fTextureMask;
uniform vec4 tipMaskColor;
bool isEques(const vec4 colorOne, const vec4 colorTwo);

void main() {
    gl_FragColor = texture2D(fTextureWhite, aFBOTextureCoord);
    vec4 rgbaMosaic = texture2D(fTextureMosaic, aFBOTextureCoord);
    if (rgbaMosaic != vec4(0, 0, 0, 0)){
        gl_FragColor = rgbaMosaic;
        vec4 rgbaMask = texture2D(fTextureMask, aCoordinate);
        if (isEques(rgbaMask, tipMaskColor)){
            gl_FragColor =  vec4(0.52157, 0.96863, 0.50588, 1) * gl_FragColor;//
        }
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
//    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
//    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}

