//#version 120 //attribute
//precision highp float;
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aMosaicCoordinate;

uniform sampler2D fTextureMask;
uniform highp sampler2D fTextureMosaic;
uniform vec4 nextPaintColors[200];//下一步要绘制的颜色数组 由于数组不可变 传递最大数组进入
uniform int nextPaintCount;//下一步要绘制的颜色数量
uniform float owh;//图片的宽高比 小于1

bool isEques(const vec4 colorOne, const vec4 colorTwo);
int modMy(float x, float y);
void main() {
    gl_FragColor = vec4(0, 0, 0, 0);//透明色
    vec4 rgba = texture2D(fTextureMask, aCoordinate);

    float dw = 1.0/16.0;
    float dh = 1.0/16.0*owh;
    float dx = (aCoordinate.x - floor(aCoordinate.x / dw) * dw)/dw;
    float dy = (aCoordinate.y - floor(aCoordinate.y / dh) * dh)/dh;
    vec2 dMosaicCoor = vec2(dx, dy);
    for (int i = 0; i<nextPaintCount;i++){
        if (isEques(rgba, nextPaintColors[i])){
            gl_FragColor = texture2D(fTextureMosaic, dMosaicCoor);
            break;
        }
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
//    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
//    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}

int modMy(float x, float y){
    return int(int(x) - int(y)*int(x/y));
}
