//#version 120 //attribute
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureMask;
uniform sampler2D fTextureWhiteFBO;
uniform sampler2D fTextureOrg;
uniform vec4 touchColor;
uniform int useWhiteFBO;//是否使用 白色中间层的FBO

bool isEques(const vec4 colorOne, const vec4 colorTwo);

void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    if (rgba == vec4(0, 0, 0, 0) || rgba == vec4(0, 0, 0, 1) || isEques(rgba, touchColor)){
        gl_FragColor = texture2D(fTextureOrg, aCoordinate);
//        gl_FragColor = vec4(0, 0, 0, 0);
    } else if (useWhiteFBO == 1) {
        gl_FragColor = texture2D(fTextureWhiteFBO, aFBOTextureCoord);
    } else {
        gl_FragColor = vec4(1, 1, 1, 1);
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
//    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
//    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}
