//#version 120 //attribute
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aMosaicCoordinate;

uniform sampler2D fTextureMask;
uniform highp sampler2D fTextureMosaic;

uniform vec4 nextPaintColors[25];//下一步要绘制的颜色数组 由于数组不可变 传递最大数组进入
uniform int nextPaintCount;//下一步要绘制的颜色数量

bool isEques(const vec4 colorOne, const vec4 colorTwo);
void main() {
    gl_FragColor = vec4(1, 1, 1, 1);
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    for (int i = 0; i<nextPaintCount;i++){
        if (isEques(rgba, nextPaintColors[i])){
            gl_FragColor = texture2D(fTextureMosaic, aMosaicCoordinate);
            break;
        }
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}

