//#version 120 //attribute
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;
uniform sampler2D fTextureMask;

uniform sampler2D fTextureWhiteFBO;
uniform vec4 touchColor;
uniform vec4 touchColorNext;
uniform int useWhiteFBO;//是否使用 白色中间层的FBO
bool isEques(const vec4 rgba, const vec4 mPointColor);
void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    if (rgba == vec4(0, 0, 0, 0) || rgba == vec4(0, 0, 0, 1) || isEques(rgba, touchColor) || isEques(rgba, touchColorNext)){
        gl_FragColor = vec4(0, 0, 0, 0);
    } else if (useWhiteFBO == 1) {
        gl_FragColor = texture2D(fTextureWhiteFBO, aFBOTextureCoord);
    } else {
        gl_FragColor = vec4(1, 1, 1, 1);
    }
}

bool isEques(const vec4 rgba, const vec4 mPointColor){
    float r = rgba.r - mPointColor.r;
    float g = rgba.g- mPointColor.g;
//    float b = rgba.b- mPointColor.b;
    //float a = rgba.a- mPointColor.a;
    if (
    (r < dx && r> -dx) &&
    (g < dx && g> -dx)
//    &&
//    (b < dx && b> -dx)
    //&& (a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}

